#include "BatteryCheck.h"

unsigned char Get_VDD(void) {
	unsigned int ADCtemp;

	PMMCTL0 = 0XA500;
	PMMCTL2 |= INTREFEN;

	ADCCTL0 |= ADCSHT_3 + ADCON;
	ADCCTL1 = ADCSHS_0 + ADCSSEL_2 + ADCDIV_0 + ADCCONSEQ_0 + ADCSHP;
	ADCMCTL0 = ADCSREF_0 + ADCINCH_13;
	ADCCTL0 |= ADCENC + ADCSC;
	while (!(ADCIFG && ADCIFG0))
		;

	ADCtemp = ADCMEM0;
	ADCtemp = ADCtemp >> 2;

	ADCCTL0 &= ~ADCENC;
	ADCCTL0 = 0;
	ADCMCTL0 = 0;
	ADCCTL1 = 0;
	PMMCTL0 = 0XA500;
	PMMCTL2 &= ~INTREFEN;

	return (unsigned char) ADCtemp;

}

void check_battery() {
	unsigned char temp;
	temp = Get_VDD();
	if (temp >= BAT_VOL_HIGH)
		SysData.SysStatus.batterylevel = none;
	else if (temp >= BAT_VOL_MIDDLE)
		SysData.SysStatus.batterylevel = stage1;
	else if (temp >= BAT_VOL_LOW)
		SysData.SysStatus.batterylevel = stage2;
	else
		SysData.SysStatus.batterylevel = stage3;
}

