/*
 * Display.h
 *
 *  Created on: Oct 11, 2013
 *      Author: a0222702
 */

#ifndef DISPLAY_H_
#define DISPLAY_H_

#include "SysDataDefinition.h"

typedef union {
	unsigned char Byte;
	struct {
		unsigned char bit0 :1;
		unsigned char bit1 :1;
		unsigned char bit2 :1;
		unsigned char bit3 :1;
		unsigned char bit4 :1;
		unsigned char bit5 :1;
		unsigned char bit6 :1;
		unsigned char bit7 :1;
	} Bits;
} BYTESTR;

extern BYTESTR LCD_Buffer0;
extern BYTESTR LCD_Buffer1;
extern BYTESTR LCD_Buffer2;
extern BYTESTR LCD_Buffer3;
extern BYTESTR LCD_Buffer4;
extern BYTESTR LCD_Buffer5;
extern BYTESTR LCD_Buffer6;
extern BYTESTR LCD_Buffer7;
extern BYTESTR LCD_Buffer8;
extern BYTESTR LCD_Buffer9;
extern BYTESTR LCD_Buffer10;
extern BYTESTR LCD_Buffer11;
extern BYTESTR LCD_Buffer12;
extern BYTESTR LCD_Buffer13;
extern BYTESTR LCD_Buffer14;
extern BYTESTR LCD_Buffer15;

#define Temp_Value_Low_a        LCD_Buffer0.Bits.bit0
#define Temp_Value_Low_b        LCD_Buffer0.Bits.bit1
#define Temp_Value_Low_c        LCD_Buffer0.Bits.bit2
#define Temp_Value_Low_d        LCD_Buffer0.Bits.bit3
#define Temp_Value_Low_f        LCD_Buffer0.Bits.bit5
#define Temp_Value_Low_g        LCD_Buffer0.Bits.bit6
#define Temp_Value_Low_e        LCD_Buffer0.Bits.bit7

#define Temp_Value_High_a       LCD_Buffer1.Bits.bit0
#define Temp_Value_High_b       LCD_Buffer1.Bits.bit1
#define Temp_Value_High_c       LCD_Buffer1.Bits.bit2
#define Temp_Value_High_d       LCD_Buffer1.Bits.bit3
#define Temp_Value_High_f       LCD_Buffer1.Bits.bit5
#define Temp_Value_High_g       LCD_Buffer1.Bits.bit6
#define Temp_Value_High_e       LCD_Buffer1.Bits.bit7

#define Mode_Name_Heat          LCD_Buffer2.Bits.bit0
#define Timer_State_Close       LCD_Buffer2.Bits.bit1
#define Screen_Area_Line        LCD_Buffer2.Bits.bit3
#define Mirror_Six_E            LCD_Buffer2.Bits.bit4
#define Mirror_Six_ADG          LCD_Buffer2.Bits.bit5
#define Mirror_Six_C            LCD_Buffer2.Bits.bit6
#define Mirror_Six_B            LCD_Buffer2.Bits.bit7

#define Fan_LR_Middle           LCD_Buffer4.Bits.bit0
#define Fan_LR_Right1           LCD_Buffer4.Bits.bit1
#define Fan_LR_Right2           LCD_Buffer4.Bits.bit2
#define Fan_LR_Left1            LCD_Buffer4.Bits.bit4
#define Fan_LR_Left2            LCD_Buffer4.Bits.bit5
#define Fan_LR_Symbol           LCD_Buffer4.Bits.bit6

#define Fan_UD_Middle           LCD_Buffer5.Bits.bit0
#define Fan_UD_Down1            LCD_Buffer5.Bits.bit1
#define Fan_UD_Down2            LCD_Buffer5.Bits.bit2
#define Fan_UD_Up1              LCD_Buffer5.Bits.bit4
#define Fan_UD_Up2              LCD_Buffer5.Bits.bit5
#define Fan_UD_Symbol           LCD_Buffer5.Bits.bit6

#define Screen_Lock_Symbol      LCD_Buffer8.Bits.bit1
#define F_TempUint_Symbol       LCD_Buffer8.Bits.bit2
#define C_TempUint_Symbol       LCD_Buffer8.Bits.bit3
#define Battery_Value_Right     LCD_Buffer8.Bits.bit4
#define Battery_Value_Middle    LCD_Buffer8.Bits.bit5
#define Battery_Value_Left      LCD_Buffer8.Bits.bit6
#define Battery_Size_Symbol     LCD_Buffer8.Bits.bit7

#define House_Temp_Outside      LCD_Buffer9.Bits.bit0
#define House_Temp_Inside       LCD_Buffer9.Bits.bit1
#define House_Size_Symbol       LCD_Buffer9.Bits.bit2
#define IR_Send_Symbol          LCD_Buffer9.Bits.bit3
#define Fan_Value_Right2        LCD_Buffer9.Bits.bit4
#define Run_State_Symbol        LCD_Buffer9.Bits.bit5
#define Fan_Auto_Symbol         LCD_Buffer9.Bits.bit6
#define Fan_Speed_Symbol        LCD_Buffer9.Bits.bit7

#define Fan_Value_Right1        LCD_Buffer10.Bits.bit0
#define Fan_Value_Middle        LCD_Buffer10.Bits.bit1
#define Fan_Value_Left1         LCD_Buffer10.Bits.bit2
#define Fan_Value_Left2         LCD_Buffer10.Bits.bit3
#define Mode_Name_Wind          LCD_Buffer10.Bits.bit4
#define Mode_Name_Dehumidity    LCD_Buffer10.Bits.bit5
#define Mode_Name_Cold          LCD_Buffer10.Bits.bit6
#define Mode_Name_Auto          LCD_Buffer10.Bits.bit7

#define Change_Air_Symbol       LCD_Buffer12.Bits.bit0
#define Health_Symbol           LCD_Buffer12.Bits.bit1
#define Aux_Heat_Symbol         LCD_Buffer12.Bits.bit2
#define Dry_Symbol              LCD_Buffer12.Bits.bit3
#define Sleep_Symbol            LCD_Buffer12.Bits.bit4
#define Max_Power_Symbol        LCD_Buffer12.Bits.bit5
#define Silent_Symbol           LCD_Buffer12.Bits.bit6
#define Auto_Symbol             LCD_Buffer12.Bits.bit7

#define Timer_Value_Low_d       LCD_Buffer13.Bits.bit0
#define Timer_Value_Low_c       LCD_Buffer13.Bits.bit1
#define Timer_Value_Low_b       LCD_Buffer13.Bits.bit2
#define Timer_Value_Low_a       LCD_Buffer13.Bits.bit3
#define Timer_Value_Low_h       LCD_Buffer13.Bits.bit4
#define Timer_Value_Low_e       LCD_Buffer13.Bits.bit5
#define Timer_Value_Low_g       LCD_Buffer13.Bits.bit6
#define Timer_Value_Low_f       LCD_Buffer13.Bits.bit7

#define Timer_Value_Middle_d    LCD_Buffer14.Bits.bit0
#define Timer_Value_Middle_c    LCD_Buffer14.Bits.bit1
#define Timer_Value_Middle_b    LCD_Buffer14.Bits.bit2
#define Timer_Value_Middle_a    LCD_Buffer14.Bits.bit3
#define Timer_Hour_Symbol       LCD_Buffer14.Bits.bit4
#define Timer_Value_Middle_e    LCD_Buffer14.Bits.bit5
#define Timer_Value_Middle_g    LCD_Buffer14.Bits.bit6
#define Timer_Value_Middle_f    LCD_Buffer14.Bits.bit7

#define Timer_Value_High_d      LCD_Buffer15.Bits.bit0
#define Timer_Value_High_c      LCD_Buffer15.Bits.bit1
#define Timer_Value_High_b      LCD_Buffer15.Bits.bit2
#define Timer_Value_High_a      LCD_Buffer15.Bits.bit3
#define Timer_State_Open        LCD_Buffer15.Bits.bit4
#define Timer_Value_High_e      LCD_Buffer15.Bits.bit5
#define Timer_Value_High_g      LCD_Buffer15.Bits.bit6
#define Timer_Value_High_f      LCD_Buffer15.Bits.bit7

extern void SET_LCD_ALL_OFF(void);
extern void SET_LCD_ALL_ON(void);
extern void dispram_init(void);
extern void display(void);

#endif /* DISPLAY_H_ */
