
#include "Infra.h"

unsigned char *send_p;
unsigned int bit_position;
unsigned int byte_counter;
unsigned char IR_stop;
unsigned char finish_flag;
BYTESTR IR_buffer[14];

void IR_reset(void) {
	unsigned char i = 5;
	IR_buffer0.Byte=0x23;  //BC
	IR_buffer1.Byte=0xCB;  //DE
	IR_buffer2.Byte=0x26;  //FG
	IR_buffer3.Byte=0x01;  //HI     user code
	IR_buffer4.Byte=0x00;  //JK
	for (i = 5; i < 14; i++)
		IR_buffer[i].Byte = 0;

	send_p = &(IR_buffer[0].Byte);
	bit_position = 0;
	byte_counter = 0;
	IR_stop = 0;
	finish_flag = 0;
	IR_Send_Symbol = 1;
	LCDMEM [9] = LCD_Buffer9.Byte;    //display send symbol
}

void IR_set(void) {
	IR_buffer0.Byte=0x23;  //BC
	IR_buffer1.Byte=0xCB;//DE
	IR_buffer2.Byte=0x26;//FG
	IR_buffer3.Byte=0x01;//HI     user code
	IR_buffer4.Byte=0x00;//JK

	//*********LM*********//
	if(SysData.SysStatus.SysON == ON)
	IR_buffer5.Bits.bit2=1;
	else
	IR_buffer5.Bits.bit2=0;

	if(SysData.SysStatus.Mute == ON)
	IR_buffer5.Bits.bit5=1;
	else
	IR_buffer5.Bits.bit5=0;

	if(SysData.CurrentMode->MaxPower == ON)
	IR_buffer5.Bits.bit6=1;
	else
	IR_buffer5.Bits.bit6=0;

	//*********NO*********//
	switch(SysData.CurrentMode->ModeName->element) {
		case ModeAuto:
		IR_buffer6.Bits.bit3=1;
		IR_buffer6.Bits.bit2=0;
		IR_buffer6.Bits.bit1=0;
		IR_buffer6.Bits.bit0=0;
		break;
		case cold:
		IR_buffer6.Bits.bit3=0;
		IR_buffer6.Bits.bit2=0;
		IR_buffer6.Bits.bit1=1;
		IR_buffer6.Bits.bit0=1;
		break;
		case dehumidity:
		IR_buffer6.Bits.bit3=0;
		IR_buffer6.Bits.bit2=0;
		IR_buffer6.Bits.bit1=1;
		IR_buffer6.Bits.bit0=0;
		break;
		case wind:
		IR_buffer6.Bits.bit3=0;
		IR_buffer6.Bits.bit2=1;
		IR_buffer6.Bits.bit1=1;
		IR_buffer6.Bits.bit0=1;
		break;
		case heat:
		IR_buffer6.Bits.bit3=0;
		IR_buffer6.Bits.bit2=0;
		IR_buffer6.Bits.bit1=0;
		IR_buffer6.Bits.bit0=1;
		break;
	}

	if(SysData.CurrentMode->AuxHeat->element== aux_heat)
	IR_buffer6.Bits.bit7=1;
	else
	IR_buffer6.Bits.bit7=0;

	//*********PG*********//
	if(SysData.CurrentMode->Temperature->element== 32)
	IR_buffer7.Byte=0xF0;
	else
	{
		IR_buffer7.Byte=(31-SysData.CurrentMode->Temperature->element);
	}

	//*********RS*********//

	switch(SysData.CurrentMode->FanSpeed->element) {

		case FanSpeedAuto:
		IR_buffer8.Bits.bit2=0;
		IR_buffer8.Bits.bit1=0;
		IR_buffer8.Bits.bit0=0;
		break;

		case ultra_low:
		IR_buffer8.Bits.bit2=0;
		IR_buffer8.Bits.bit1=1;
		IR_buffer8.Bits.bit0=0;
		break;

		case low:
		IR_buffer8.Bits.bit2=0;
		IR_buffer8.Bits.bit1=1;
		IR_buffer8.Bits.bit0=0;
		break;

		case middle:
		IR_buffer8.Bits.bit2=0;
		IR_buffer8.Bits.bit1=1;
		IR_buffer8.Bits.bit0=1;
		break;

		case large:
		IR_buffer8.Bits.bit2=1;
		IR_buffer8.Bits.bit1=0;
		IR_buffer8.Bits.bit0=1;
		break;

		case strong:
		IR_buffer8.Bits.bit2=1;
		IR_buffer8.Bits.bit1=0;
		IR_buffer8.Bits.bit0=1;
		break;

		default : break;

	}

	switch(SysData.CurrentMode->UpDwnFanMode->element) {

		case position_none:
		IR_buffer8.Bits.bit5=0;
		IR_buffer8.Bits.bit4=0;
		IR_buffer8.Bits.bit3=0;
		break;
		case position_5:
		IR_buffer8.Bits.bit5=1;
		IR_buffer8.Bits.bit4=1;
		IR_buffer8.Bits.bit3=1;
		break;

		default : break;
	}

	IR_buffer9.Byte =0; //TU
	IR_buffer10.Byte=0;//VW
	IR_buffer11.Byte=0;//XY
	IR_buffer12.Byte=0;//ZA

	IR_buffer13.Byte=(IR_buffer0.Byte+IR_buffer1.Byte+IR_buffer2.Byte+IR_buffer3.Byte+IR_buffer4.Byte+IR_buffer5.Byte+
			IR_buffer6.Byte+IR_buffer7.Byte+ IR_buffer8.Byte+IR_buffer9.Byte+IR_buffer10.Byte+IR_buffer11.Byte+IR_buffer12.Byte);//ZZ

	send_p= &(IR_buffer[0].Byte);
	bit_position = 0;
	byte_counter=0;
	IR_stop=0;
	finish_flag=0;
	IR_Send_Symbol=1;
	LCDMEM[9] = LCD_Buffer9.Byte;
}

void IR_send(void) {
	P1SEL0 |= BIT0;
	_DINT();
	SYSCFG1 = IRDSSEL + IREN;
	TA0CCTL0 = CCIE;
	TA0CCTL2 = OUTMOD_7;                   // out mod: reset/set
	TA1CCTL2 = OUTMOD_7;                   // out mod: reset/set
	// 38.09k carrier waveform length setting
	TA1CCR2 = 35;                          // 8.75us
	TA1CCR0 = 105;                         // 26.3us

	TA0CCR2 = 20;
	TA0CCR0 = 40;

	TA1CTL = TASSEL_2 + MC_1 + TACLR;         //SMCLK, up mode
	TA0CTL = TASSEL_2 + ID__4 + MC_1 + TACLR; //SMCLK, /2, up mode

	_EINT();

	while (IR_stop == 0)
		;

	TA0CCTL0 = 0;
	TA0CCTL2 = 0;
	TA0CCTL1 = 0;
	TA0CTL = 0;
	TA0R = 0;
	TA0CCR0 = 0;
	TA0CCR2 = 0; //disable timer1

	TA1CCTL0 = 0;
	TA1CCTL2 = 0;
	TA1CCTL1 = 0;
	TA1CTL = 0;
	TA1R = 0;
	TA1CCR0 = 0;
	TA1CCR2 = 0; //disable timer1

	IR_Send_Symbol = 0;
	LCDMEM [9] = LCD_Buffer9.Byte;
}

void Infrared_Send() {
	if ((TA1CTL & BIT4)||(timer_finish_flag)) //15-timer is working, IR_send only happen when key pressed
{	if(SysData.SysStatus.SysLock)
	return;

	if(TA1CTL & BIT4)
	{
		if((SysData.SysStatus.SysON == OFF)&&(on2off_flag==1))
		{
			IR_reset();
			IR_send();
			return;
		}
		else if(SysData.SysStatus.SysON == OFF)
		return;

		IR_set();
		IR_send();
	}

	if(timer_finish_flag==1)
	{
		IR_set();
		IR_send();
	}

	else;
}
}
