
#include "Display.h"

void load_lcdmem(void);
void temp_value_unit_display();
void mode_name_display();
void fan_speed_display();
void battery_line_run_lock_diaplay();
void sleep_mode_display();
void silent_mode_display();
void max_power_display();
void save_power_display();
void wind_LR_display();
void wind_UD_display();
void temp_positon_display();
void dry_health_display();
void timer_display();

BYTESTR LCD_Buffer0 ;
BYTESTR LCD_Buffer1 ;
BYTESTR LCD_Buffer2 ;
BYTESTR LCD_Buffer3 ;
BYTESTR LCD_Buffer4 ;
BYTESTR LCD_Buffer5 ;
BYTESTR LCD_Buffer6 ;
BYTESTR LCD_Buffer7 ;
BYTESTR LCD_Buffer8 ;
BYTESTR LCD_Buffer9 ;
BYTESTR LCD_Buffer10;
BYTESTR LCD_Buffer11;
BYTESTR LCD_Buffer12;
BYTESTR LCD_Buffer13;
BYTESTR LCD_Buffer14;
BYTESTR LCD_Buffer15;

const unsigned char  Digtal_Table_eight[]=
{
     0xAF,    //10101111,      //0
     0x06,    //00000110,      //1
     0xCB,    //11001011,      //2
     0x4F,    //01001111,      //3
     0x66,    //01100110,      //4
     0x6D,    //01101101,      //5
     0xED,    //11101101,      //6
     0x07,    //00000111,      //7
     0xEF,    //11101111,      //8
     0x6F,    //01101111,      //9
     0xE6,    //11100110,      //H
     0xEF,    //11101111,      //B
     0xA9,    //10101001,      //C
     0xAF,    //10101111,      //D
     0xE9,    //11101001,      //E
     0xE1     //11100001       //F
};

const unsigned char  Timer_Digtal_Table_eight[]=
{
     0xAF,    //10101111,      //0
	 0x06,    //00000110,      //1
     0x6D,    //01101101,      //2
     0x4F,    //01001111,      //3
     0xC6,    //11000110,      //4
     0xCB,    //11001011,      //5
     0xEB,    //11101011,      //6
     0x0E,    //00001110,      //7
     0xEF,    //11101111,      //8
     0xCF,    //11001111,      //9
};

const unsigned char  Mirror_Six_Table_eight[]=
{
     0xF0,    //11110000,      //Mirror 6
	 0xC0,    //11000000,      //1
     0x70,    //01110000,      //2
     0xE0,    //11100000,      //3
};

void SET_LCD_ALL_ON(void)
{
	 LCDMEM[0]  =  0xff;
	 LCDMEM[1]  =  0xff;
	 LCDMEM[2]  =  0xff;
	 LCDMEM[4]  =  0xff;
	 LCDMEM[5]  =  0xff;
	 LCDMEM[8]  =  0xff;
	 LCDMEM[9]  =  0xff;
	 LCDMEM[10] =  0xff;
	 LCDMEM[12] =  0xff;
	 LCDMEM[13] =  0xff;
	 LCDMEM[14] =  0xff;
	 LCDMEM[15] =  0xff;
	 LCDMEM[6]  =  0x21;
	 LCDMEM[7]  =  0x84;
}


void SET_LCD_ALL_OFF(void)
{
	 LCDMEM[0]  =  0x00;
	 LCDMEM[1]  =  0x00;
	 LCDMEM[2]  =  0x00;
	 LCDMEM[4]  =  0x00;
	 LCDMEM[5]  =  0x00;
	 LCDMEM[8]  =  0x00;
	 LCDMEM[9]  =  0x00;
	 LCDMEM[10] =  0x00;
	 LCDMEM[12] =  0x00;
	 LCDMEM[13] =  0x00;
	 LCDMEM[14] =  0x00;
	 LCDMEM[15] =  0x00;
	 LCDMEM[16] =  0x00;
}

void dispram_init()
{
	 SET_LCD_ALL_OFF();
	 LCD_Buffer0.Byte = 0;
	 LCD_Buffer1.Byte = 0;
	 LCD_Buffer2.Byte = 0;
	 LCD_Buffer3.Byte = 0;
	 LCD_Buffer4.Byte = 0;
	 LCD_Buffer5.Byte = 0;
	 LCD_Buffer6.Byte = 0;
	 LCD_Buffer7.Byte = 0;
	 LCD_Buffer8.Byte = 0;
	 LCD_Buffer9.Byte = 0;
	 LCD_Buffer10.Byte = 0;
	 LCD_Buffer11.Byte = 0;
	 LCD_Buffer12.Byte = 0;
	 LCD_Buffer13.Byte = 0;
	 LCD_Buffer14.Byte = 0;
	 LCD_Buffer15.Byte = 0;
}

void  display(void)
{
	 dispram_init();
	 mode_name_display();
	 temp_value_unit_display();
	 fan_speed_display();
	 battery_line_run_lock_diaplay();
	 sleep_mode_display();
	 silent_mode_display();
	 max_power_display();
	 save_power_display();
	 wind_LR_display();
	 wind_UD_display();
	 temp_positon_display();
	 dry_health_display();
	 timer_display();

	 load_lcdmem();
}


void mode_name_display()
{
	switch(SysData.CurrentMode->ModeName->element){
	case ModeAuto:
		Mode_Name_Auto =1;
		break;
	case cold:
		Mode_Name_Cold =1;
		break;
	case dehumidity:
		Mode_Name_Dehumidity =1;
		break;
	case wind:
		Mode_Name_Wind =1;
		break;
	case heat:
		Mode_Name_Heat =1;
		break;
	default : break;

	}
}


void temp_value_unit_display()
{
  unsigned char temp;
  unsigned char bcd_data_H;
  unsigned char bcd_data_L;

  temp=SysData.CurrentMode->Temperature->element;
  bcd_data_H=( temp/10 );
  bcd_data_L=( temp%10 );   //change HEX DATA TO BCD DATA

  LCD_Buffer0.Byte = Digtal_Table_eight[bcd_data_L]; //low  byte
  LCD_Buffer1.Byte = Digtal_Table_eight[bcd_data_H]; //high byte

  if(SysData.SysStatus.TemperatureMode == Cels)
  {
	  C_TempUint_Symbol=1;
  }
  if(SysData.SysStatus.TemperatureMode == Fah)
  {
	  F_TempUint_Symbol=1;
  }
}



void fan_speed_display()
{
    switch(SysData.CurrentMode->FanSpeed->element){

    case  FanSpeedAuto:
    	Fan_Speed_Symbol=1;
    	Fan_Auto_Symbol=1;
    	break;

    case  ultra_low:
    	Fan_Speed_Symbol=1;
    	Fan_Value_Left2=1;
    	break;

    case low:
    	Fan_Speed_Symbol=1;
    	Fan_Value_Left2=1;
    	Fan_Value_Left1=1;
    	break;

    case  middle:
    	Fan_Speed_Symbol=1;
    	Fan_Value_Left2=1;
    	Fan_Value_Left1=1;
    	Fan_Value_Middle=1;
    	break;

    case  large:
    	Fan_Speed_Symbol=1;
        Fan_Value_Left2=1;
        Fan_Value_Left1=1;
        Fan_Value_Middle=1;
        Fan_Value_Right1=1;
        break;

    case  strong:
    	Fan_Speed_Symbol=1;
        Fan_Value_Left2=1;
        Fan_Value_Left1=1;
        Fan_Value_Middle=1;
        Fan_Value_Right1=1;
        Fan_Value_Right2=1;
        break;

    default : break;

    }
}


void battery_line_run_lock_diaplay()
{
	 Screen_Area_Line =1;                      //screen area line light on

	 switch(SysData.SysStatus.batterylevel){   // battery level display

	 case  none:
		 Battery_Size_Symbol=1;
	     break;
	 case  stage1:
		 Battery_Size_Symbol=1;
		 Battery_Value_Left=1;
		 break;
	 case  stage2:
	 	 Battery_Size_Symbol=1;
	 	 Battery_Value_Left=1;
	 	 Battery_Value_Middle=1;
	 	 break;
	 case  stage3:
		 Battery_Size_Symbol=1;
		 Battery_Value_Left=1;
		 Battery_Value_Middle=1;
		 Battery_Value_Right=1;
		 break;

	 default : break;
	 }


	 switch(SysData.SysStatus.SysON){         // run symbol display

	 case  ON:
		 Run_State_Symbol=1;
	 	 break;
	 case  OFF:
		 Run_State_Symbol=0;
		 break;
	 default : break;
	 }

	 switch(SysData.SysStatus.SysLock){         // lock symbol display

	 case  ON:
		 Screen_Lock_Symbol=1;
	 	 break;
	 case  OFF:
		 Screen_Lock_Symbol=0;
		 break;
	 default : break;
	 }
}


void sleep_mode_display()
{
	switch(SysData.CurrentMode->SleepMode->element){

    case  sleepmode_start:      // don't sleep
    //	SysData.SysStatus.Mute=0;  //静音
	     ;
    break;

    case  sleepmode_1:          //sleep mode 1
    	Sleep_Symbol=1;
    	LCD_Buffer2.Byte&=0x0F;
    	LCD_Buffer2.Byte|=Mirror_Six_Table_eight[sleepmode_1];
    	LCD_Buffer12.Bits.bit7=1;  //自动
	break;

    case  sleepmode_2:          //sleep mode  2
    	Sleep_Symbol=1;
    	LCD_Buffer2.Byte&=0x0F; //clear the value of last time
    	LCD_Buffer2.Byte|=Mirror_Six_Table_eight[sleepmode_2];
    	LCD_Buffer12.Bits.bit7=1;  //自动
	break;

    case  sleepmode_end:        //sleep mode   3
    	Sleep_Symbol=1;
    	LCD_Buffer2.Byte&=0x0F;
    	LCD_Buffer2.Byte|=Mirror_Six_Table_eight[sleepmode_end];
    	LCD_Buffer12.Bits.bit7=1;  //自动
	break;

    default : break;
    }
}


void wind_UD_display()
{
	switch(SysData.CurrentMode->UpDwnFanMode->element){

	case position_none:
		Fan_UD_Symbol =0;
		Fan_UD_Down2 =0;
		Fan_UD_Down1 =0;
		Fan_UD_Middle =0;
		Fan_UD_Up1 =0;
		Fan_UD_Up2 =0;
		break;
//	case position_1:
//		Fan_UD_Symbol =1;
//		Fan_UD_Down2 =1;
//		break;
//	case position_2:
//		Fan_UD_Symbol =1;
//		Fan_UD_Down2 =1;
//		Fan_UD_Down1 =1;
//		break;
//	case position_3:
//		Fan_UD_Symbol =1;
//		Fan_UD_Down2 =1;
//		Fan_UD_Down1 =1;
//		Fan_UD_Middle =1;
//		break;
//	case position_4:
//		Fan_UD_Symbol =1;
//		Fan_UD_Down2 =1;
//		Fan_UD_Down1 =1;
//		Fan_UD_Middle =1;
//		Fan_UD_Up1 =1;
//		break;
	case position_5:
		Fan_UD_Symbol =1;
		Fan_UD_Down2 =1;
		Fan_UD_Down1 =1;
		Fan_UD_Middle =1;
		Fan_UD_Up1 =1;
		Fan_UD_Up2 =1;
		break;

    default : break;
	}

}

void wind_LR_display()
{
	switch(SysData.CurrentMode->LeftRightFanMode->element){

    case position_none:
	    Fan_LR_Symbol =0;
	    Fan_LR_Right2 =0;
	    Fan_LR_Right1 =0;
	    Fan_LR_Middle =0;
	    Fan_LR_Left1 =0;
	    Fan_LR_Left2 =0;
	    break;
//    case position_1:
//	    Fan_LR_Symbol =1;
//	    Fan_LR_Right2 =1;
//	    break;
//    case position_2:
//	    Fan_LR_Symbol =1;
//	    Fan_LR_Right2 =1;
//	    Fan_LR_Right1 =1;
//	    break;
//    case position_3:
//    	Fan_LR_Symbol =1;
//     	Fan_LR_Right2 =1;
//	    Fan_LR_Right1 =1;
//	    Fan_LR_Middle =1;
//	    break;
//    case position_4:
//     	Fan_LR_Symbol =1;
//    	Fan_LR_Right2 =1;
//	    Fan_LR_Right1 =1;
//	    Fan_LR_Middle =1;
//	    Fan_LR_Left1 =1;
//	    break;
    case position_5:
	    Fan_LR_Symbol =1;
	    Fan_LR_Right2 =1;
	    Fan_LR_Right1 =1;
	    Fan_LR_Middle =1;
	    Fan_LR_Left1 =1;
	    Fan_LR_Left2 =1;
	    break;

   default : break;
   }
}

void temp_positon_display()
{
	switch(SysData.SysStatus.TempPositon->element){

	case Temp_none:
		House_Size_Symbol =0;
		House_Temp_Inside =0;
		House_Temp_Outside=0;
	    break;

	case Temp_inside:
		House_Size_Symbol =1;
		House_Temp_Inside =1;
		House_Temp_Outside=0;
		break;

	case Temp_outside:
		House_Size_Symbol =1;
		House_Temp_Inside =0;
		House_Temp_Outside=1;
		break;

	default : break;
	}
}

void max_power_display()
{
	 switch(SysData.CurrentMode->MaxPower){

	 case  ON:
		 Max_Power_Symbol =1;
	 	 break;
	 case  OFF:
		 Max_Power_Symbol =0;
		 break;
	 default : break;
	 }
}

void save_power_display()
{
	  unsigned char temp;
	  unsigned char bcd_data_H;
	  unsigned char bcd_data_L;

	  temp=SysData.CurrentMode->Temperature->element;
	  bcd_data_H=( temp/10 );
	  bcd_data_L=( temp%10 );   //change HEX DATA TO BCD DATA

	  LCD_Buffer0.Byte = Digtal_Table_eight[bcd_data_L]; //low  byte
	  LCD_Buffer1.Byte = Digtal_Table_eight[bcd_data_H]; //high byte

	  switch(SysData.CurrentMode->SavePower)
	    {
		 case  ON:
			 LCD_Buffer0.Byte = Digtal_Table_eight[14]; //low  byte
			 LCD_Buffer1.Byte = Digtal_Table_eight[5]; //high byte
			 C_TempUint_Symbol=0;
		 	 break;
		 case  OFF:
			 LCD_Buffer0.Byte = Digtal_Table_eight[bcd_data_L]; //low  byte
			 LCD_Buffer1.Byte = Digtal_Table_eight[bcd_data_H]; //high byte
			 C_TempUint_Symbol=1;
			 break;
		 default : break;
		 }
}


void silent_mode_display()
{
	switch(SysData.SysStatus.Mute){

     case  ON:
    	 Silent_Symbol =1;
	     break;
     case  OFF:
    	 Silent_Symbol=0;
	     break;
     default : break;
     }
}

void dry_health_display()
{
//	switch(SysData.CurrentMode->Dry){
//
//     case  ON:
//    	 Dry_Symbol=1;
//	     break;
//     case  OFF:
//    	 Dry_Symbol=0;
//	     break;
//     default : break;
//     }
	switch(SysData.CurrentMode->AuxHeat->element){

	     case  aux_none:
	    	 Dry_Symbol=0;
	    	 Aux_Heat_Symbol=0;
		     break;
	     case  dry:
	    	 Dry_Symbol=1;
	    	 Aux_Heat_Symbol=0;
		     break;
	     case  aux_heat:
	    	 Dry_Symbol=0;
	    	 Aux_Heat_Symbol=1;
	    	 break;
	     default : break;
	     }

	switch(SysData.CurrentMode->Healthy){

     case  ON:
    	 Health_Symbol=1;
	     break;
     case  OFF:
    	 Health_Symbol=0;
	     break;
     default : break;
     }
}

void timer_display()
{
    unsigned char temp;
    unsigned char bcd_data_H;
	unsigned char bcd_data_L;

	temp=SysData.SysStatus.TimerValue->element;
	bcd_data_H=( temp/10);
	bcd_data_L=( temp%10 );   //change HEX DATA TO BCD DATA

	LCD_Buffer14.Byte = Timer_Digtal_Table_eight[bcd_data_L]; //low  byte
	LCD_Buffer15.Byte = Timer_Digtal_Table_eight[bcd_data_H]; //high byte

    LCD_Buffer13.Byte = Timer_Digtal_Table_eight[SysData.SysStatus.TimerMinuterValue->element];
    LCD_Buffer13.Bits.bit4 =1;//minuter

    if(SysData.SysStatus.SysON==OFF)
    {
	switch(SysData.SysStatus.TimerMode1->element){      //display timer mode: shutdown or startup
	case Timer_none1:
		Timer_Hour_Symbol=0;
		Timer_State_Close=0;
		Timer_State_Open =0;
		LCD_Buffer14.Byte = 0;
		LCD_Buffer15.Byte = 0;
	    LCD_Buffer13.Byte = 0;
		break;

	case Timer_startup:
		Timer_Hour_Symbol=1;
		Timer_State_Close=0;
		Timer_State_Open =1;
		break;
    default : break;
	 }
    }

    if(SysData.SysStatus.SysON==ON)
     {
 	switch(SysData.SysStatus.TimerMode2->element){      //display timer mode: shutdown or startup
 	case Timer_none2:
 		Timer_Hour_Symbol=0;
 		Timer_State_Close=0;
 		Timer_State_Open =0;
		LCD_Buffer14.Byte = 0;
		LCD_Buffer15.Byte = 0;
	    LCD_Buffer13.Byte = 0;
 		break;

 	case Timer_shutdown:
 		Timer_Hour_Symbol=1;
 		Timer_State_Close=1;
 		Timer_State_Open =0;
 		break;
     default : break;
 	 }
    }
}

void load_lcdmem(void){
	LCDMEM[0]  =  LCD_Buffer0.Byte;
	LCDMEM[1]  =  LCD_Buffer1.Byte;
	LCDMEM[2]  =  LCD_Buffer2.Byte;
	LCDMEM[4]  =  LCD_Buffer4.Byte;
	LCDMEM[5]  =  LCD_Buffer5.Byte;
	LCDMEM[8]  =  LCD_Buffer8.Byte;
	LCDMEM[9]  =  LCD_Buffer9.Byte;
	LCDMEM[10] =  LCD_Buffer10.Byte;
	LCDMEM[12] =  LCD_Buffer12.Byte;
	LCDMEM[13] =  LCD_Buffer13.Byte;
	LCDMEM[14] =  LCD_Buffer14.Byte;
	LCDMEM[15] =  LCD_Buffer15.Byte;
}
