/*
 * Interrupt.c
 *
 *  Created on: Oct 22, 2013
 *      Author: a0222702
 */

#include "Interrupt.h"
#include "Infra.h"

//********RTC timer interrupt ISR*********//
#pragma vector=RTC_VECTOR
__interrupt void RTC_ISR(void)
{
    switch(__even_in_range(RTCIV,RTCIV_RTCIF))
    {
        case  RTCIV_NONE:   break;                          // No interrupt
        case  RTCIV_RTCIF:  SysData.SysStatus.RTCtimerInterruptFlag =1;
                            break;
        default: break;
    }
    LPM3_EXIT;
}

//********Potr1 interrupt ISR*********//
#pragma vector = PORT1_VECTOR
__interrupt void KEY_ISR(void)
{
    P1IFG = 0;
    SysData.SysStatus.keypressed=1;
    TA1CCR0 = 60000;
    TA1CTL = TASSEL_2 + MC_1;
    TA1CCTL0 |= CCIE;
    LPM3_EXIT;
}

//********Timer1 interrupt ISR*********//
#pragma vector = TIMER1_A0_VECTOR
__interrupt void TIMER1_A0_ISR(void)
{
    SysData.SysStatus.KeydelayInterruptFlag = 1;
}

//********Timer0 interrupt ISR*********//
#pragma vector = TIMER0_A0_VECTOR
__interrupt void TIMER0_A0_ISR (void)
{
	        if(finish_flag)
	        {
	        	IR_stop=1;
	        }
	     	if((byte_counter==0)&& (bit_position==0)) // preamble length setting
	    	{
	     		TA0CCR2 = 3200;                       // 3.2ms高
	            TA0CCR0 = 4600;                       // 4.6ms低
	            byte_counter++;
	            bit_position++;
	    	}
	    	else if((byte_counter==15)&& (bit_position==1)) // postamble length setting
	    	{
	    		 TA0CCR2 = 500;  //0.5ms高  表示结束
	             TA0CCR0 = 500; //1ms   待定
	             finish_flag=1;
	      	}

	    	else
	    	{
	    		if((*send_p & bit_position) == 0)
	    		{
	               TA0CCR2 = 500;   //0.63ms高             // '0'
		           TA0CCR0 = 830;   //0.56ms低
	    		   bit_position<<=1;
	    		   if(bit_position==256)
	    		   {
	    			   send_p++;
	    			   byte_counter++;
	    			   bit_position=1;
	    		   }
	    		}
             else
                {
	    	       TA0CCR2 = 500;   //0.63ms高             // '1'
	               TA0CCR0 = 1580;   //1.66ms低
	    		   bit_position<<=1;
	    		   if(bit_position==256)
	    		   {
	    		       send_p++;
	    		       byte_counter++;
	    		       bit_position=1;
	    		   }
	            }

	    	}
}
