#include "MSP430FR4133.h"
#include "MCUinit.h"

void Clr_Ram(void);
void Clr_Fram(void);

void MCU_init(void)
{
   WDTCTL = WDTPW + WDTHOLD;               // stop WDT to avoid generating timeout

   Clr_Ram();                        //20120830
   Clr_Fram();

/*******Configure clock system********************/
   PM5CTL0 &= ~LOCKLPM5;                   // Unlock I/O
    P4SEL0 |= BIT1 | BIT2;                  // set XT1 pin as second function

    do
    {
        CSCTL7 &= ~(XT1OFFG | DCOFFG);      // Clear XT1 and DCO fault flag
        SFRIFG1 &= ~OFIFG;
    }while (SFRIFG1 & OFIFG);               // Test oscillator fault flag

  //  __delay_cycles(1000000);
    
   CSCTL1 |= DCORSEL_3;
   CSCTL2 = 0x107A;
   //CSCTL4 = 0;
   //CSCTL5 = 0;                              // MCLK~4MHz; SMCLK~4MHz


/*******Configure LCD********************/
   SYSCFG2 |= LCDPCTL;      // R13/R23/R33/LCDC1/LCDC2 pins selected
   //LCDCTL0  = LCD4MUX | (7<<11);
   LCDCTL0  = LCD4MUX | (7<<11);
   LCDPCTL0 = 0xFFFF;//ä½¿èƒ½LCDé©±åŠ¨æ®µ
   LCDPCTL1 = 0xFFFF;//ä½¿èƒ½LCDé©±åŠ¨æ®µ
   LCDPCTL2 = 0x0000;//ä½¿èƒ½LCDé©±åŠ¨æ®µ

   LCDVCTL = LCDCPEN + LCDSELVDD;       // bias generator mode: 2
   LCDCSSEL0 = 0xF000;// L12,L13, L14, L15: COM pins
   LCDCSSEL1 = 0x0000;
   LCDCSSEL2 = 0x0000;
   LCDM6 = 0x21;
   LCDM7 = 0x84;
   LCDCTL0 |= LCDON;


/*******Configure KEY GPIO********************/
   P1DIR &= ~(BIT1 + BIT2 + BIT3 + BIT5+BIT6);//P1.1/1.2/1.3/1.5/1.6
   P1REN |= (BIT1 + BIT2 + BIT3 + BIT5+BIT6);//P1.1/1.2/1.3/1.5/1.6
   P1OUT |= (BIT1 + BIT2 + BIT3 + BIT5+BIT6);//P1.1/1.2/1.3/1.5/1.6
   P1IES |= (BIT1 + BIT2 + BIT3 + BIT5);//p1.1/1.2/1.3/1.5 interrupt edge
   P1IFG = 0;
   P1IE |= (BIT1 + BIT2 + BIT3 + BIT5);
   P5DIR |= (BIT0 + BIT1 + BIT2 + BIT3);//P5.0/5.1/5.2/5.3
   P5OUT &= ~(BIT0 + BIT1 + BIT2 + BIT3);//P5.0/5.1/5.2/5.3 all clear


/****configure RTC as 16 bit counter and 0.5s timer interval*****/
   RTCMOD = 384;//3s
// RTCMOD = 64;//0.5s
   RTCCTL |= RTCSS__XT1CLK | RTCSR |RTCPS__256;
   RTCCTL |= RTCIE;


/****unused GPIO configuration, P1.7/ P4.0 / P5.4/ P5.5/ P5.6 / P5.7 /P8.0/P8.1/P8.2/P8.3/å�‡è®¾ç½®æˆ�è¾“å‡º****/
   P1OUT &= ~(BIT7+BIT4);
   P1DIR |= BIT7+BIT4;
   P4OUT &= ~BIT0;
   P4DIR |= BIT0;
   P5OUT &= ~(BIT4 + BIT5+BIT6+BIT7);
   P5DIR |= (BIT4 + BIT5+BIT6+BIT7);

   P8OUT &= ~(BIT0 + BIT1 + BIT2 + BIT3);
   P8DIR |= (BIT0 + BIT1 + BIT2 + BIT3);
}

void Clr_Ram(void)
{
   unsigned char *ppp = 0;
   unsigned int iii = 0;
   ppp = (unsigned char *) 0x2000;
   for (iii = 0; iii < 800; iii++)
   {
       *ppp = 0;
        ppp++;
   }
}


void Clr_Fram(void)
{
   unsigned char *ppp = 0;
   unsigned int iii = 0;
   ppp = (unsigned char *) 0x1800;
   for (iii = 0; iii < 200; iii++)
   {
       *ppp = 0;
        ppp++;
   }
}


void MCU_initlpm(void)
{
   WDTCTL = WDTPW + WDTHOLD;               // stop WDT to avoid generating timeout

   //Clr_Ram();                        //20120830

/*******Configure clock system********************/
   P4SEL0 |= (BIT1+BIT2);                   // P4.2~P4.1: XOUT~XIN

   CSCTL1 |= DCORSEL_3;                 // DCO range~8MHz
   CSCTL2 = 0x107A;                     // DCOCLKDIV 4MHz
 //CSCTL4 = 0;                          // MCLK~4MHz; SMCLK~4MHz
// CSCTL5 = 0;



/*******Configure LCD********************/
   SYSCFG2 |= LCDPCTL;      // R13/R23/R33/LCDC1/LCDC2 pins selected

/*******Configure KEY GPIO********************/
   P1DIR &= ~(BIT1 + BIT2 + BIT3 + BIT5+BIT6);//P1.1/1.2/1.3/1.5/1.6
   P1REN |= (BIT1 + BIT2 + BIT3 + BIT5+BIT6);//P1.1/1.2/1.3/1.5/1.6
   P1OUT |= (BIT1 + BIT2 + BIT3 + BIT5+BIT6);//P1.1/1.2/1.3/1.5/1.6
   P1IES |= (BIT1 + BIT2 + BIT3 + BIT5);//p1.1/1.2/1.3/1.5 interrupt edge
   P1IFG = 0;
   P1IE |= (BIT1 + BIT2 + BIT3 + BIT5);
   P5DIR |= (BIT0 + BIT1 + BIT2 + BIT3);//P5.0/5.1/5.2/5.3
   P5OUT &= ~(BIT0 + BIT1 + BIT2 + BIT3);//P5.0/5.1/5.2/5.3 all clear


/****configure RTC as 16 bit counter and 0.5s timer interval*****/
// RTCMOD = 768;//768*256/32768=6s
   RTCMOD = 384;//384*256/32768=3s
// RTCMOD = 64;//64*256/32768=0.5s
// RTCMOD = 128;
   RTCCTL |= RTCSS__XT1CLK |RTCPS__256; //clock source=XT1CLK,prediv=256,count clear,interrupt enable
   // don't clear the counter
   RTCCTL |= RTCIE;



/****unused GPIO configuration, P1.7/ P4.0 / P5.4/ P5.5/ P5.6 / P5.7 /P8.0/P8.1/P8.2/P8.3/均设置成输出****/
   P1OUT &= ~(BIT7+BIT4);
   P1DIR |= BIT7+BIT4;
   P4OUT &= ~BIT0;
   P4DIR |= BIT0;
   P5OUT &= ~(BIT4 + BIT5+BIT6+BIT7);
   P5DIR |= (BIT4 + BIT5+BIT6+BIT7);

   P8OUT &= ~(BIT0 + BIT1 + BIT2 + BIT3);
   P8DIR |= (BIT0 + BIT1 + BIT2 + BIT3);

   PM5CTL0 &= ~LOCKLPM5;                   // Unlock I/O
   /***wait for xtal to stablize***/
    P4SEL0 |= BIT1 | BIT2;                  // set XT1 pin as second function

    do
    {
        CSCTL7 &= ~(XT1OFFG | DCOFFG);      // Clear XT1 and DCO fault flag
        SFRIFG1 &= ~OFIFG;
    }while (SFRIFG1 & OFIFG);               // Test oscillator fault flag

}



