/*
 * SysDataDefinition.h
 *
 *  Created on: Sep 26, 2013
 *      Author: a0282243
 */

#ifndef SYSDATADEFINITION_H_
#define SYSDATADEFINITION_H_

#define ON 1
#define OFF 0
#define MODE_NUM 5
#define CELS_TEMP_NUM 17
#define FATH_TEMP_NUM 21
#define Timer_Value_NUM 24
#define Timer_Minuter_Value_NUM 6
#define SINGLE_DIRECTION 0
#define DUAL_DIRECTION 1

enum mode {ModeAuto = 0, cold, dehumidity,wind, heat };
enum FanSpeed {FanSpeedAuto = 0, ultra_low,low, middle, large, strong, max };
enum FanMode {position_none =0/*, position_1, position_2,position_3, position_4*/, position_5};
enum TemperatureMode {Cels =0,Fah};
enum TemperaturePosition {Temp_none=0,Temp_inside,Temp_outside};
enum TimerMode1 {Timer_none1=0,Timer_startup};
enum TimerMode2 {Timer_none2=0,Timer_shutdown};
enum SleepMode {sleepmode_start =0,sleepmode_1,sleepmode_2,sleepmode_end};
enum AuxHeatmode {aux_none=0,dry,aux_heat};
enum BehaviorPhase {bringup =0,idle ,keyscan,keyprocess,infrasend};
enum BatteryValue {none =0, stage1, stage2, stage3 };
enum keyvalue {Key_On_off = 14, Key_Mode=15,Key_Fan_Speed=16, Key_Plus=11,Key_Minus=7,Key_Sleep=5,Key_TimerDelay=1,Key_SavePower=8,
	           Key_Dry=2,Key_Health=4,Key_Temp_Position=3,Key_Light=12,Key_Mute=6,Key_Max_Power=10,Key_UpDwn_wind=17,Key_LeftRt_Wind=18 ,Key_Lock=21};

typedef struct CircleLink {
    unsigned char element;
    struct CircleLink  *next;
    struct CircleLink  *previous;
} CircleLink;



typedef struct {
    CircleLink *Temperature ;
    CircleLink *FanSpeed ;
    CircleLink *LeftRightFanMode;
    CircleLink *UpDwnFanMode;
    CircleLink *SleepMode;
    CircleLink *ModeName;
    unsigned char Healthy  ;
    unsigned char Dry ;
    unsigned char Heat ;
    unsigned char MaxPower ;
    unsigned char Auto;
    unsigned char SavePower;
    CircleLink *AuxHeat;

} ModeStruct;

typedef struct {
    unsigned char SysON :1;
    unsigned char SysLock :1;
    unsigned char TimerDelayON :1;
    unsigned char Mute :1;
    unsigned char light :1;
    unsigned char keypressed :1;
    unsigned char TemperatureMode : 2;
    unsigned char BehavirPhase : 3;
    unsigned int  TimerDelayMinutesLeft;
    unsigned char RTCtimerInterruptFlag :1;
    unsigned char KeydelayInterruptFlag :1;
    unsigned char KeyShift :1;
    unsigned char batterylevel  :2;
    CircleLink *TempPositon;
    CircleLink *TimerMode1;
    CircleLink *TimerMode2;
    CircleLink *TimerValue;
    CircleLink *TimerMinuterValue;
//    CircleLink *AuxHeat;
} StatusStruct;


typedef struct {

ModeStruct *CurrentMode;
StatusStruct SysStatus;
ModeStruct  SysMode[MODE_NUM];

} SysDataStruct;



extern const unsigned char ModeArray[];
extern const unsigned char FanSpeedArray[];
extern const unsigned char FanLeftRightFanMode[];
extern const unsigned char FanUpdwnFanMode[];
extern const unsigned char TemperatureMode[];
extern const unsigned char SleepMode[] ;
extern const unsigned char AuxHeatmode[];
extern const unsigned char BehaviorPhase[];
extern const unsigned char KeyValueArray[];
extern const unsigned char CelsTemperatureRange[];
extern const unsigned char FahTemperatureRange[];
extern const unsigned char TemperaturePositionMode[];
extern CircleLink TimerValueCircleLink[24];
extern CircleLink TimerMinuterValueCircleLink[6];
extern CircleLink TimerMode1CircleLink[2];
extern CircleLink TimerMode2CircleLink[2];
extern SysDataStruct SysData;

void InitSysData(void);

#endif /* SYSDATADEFINITION_H_ */
