
#include "MSP430FR4133.h"
#include "MCUinit.h"
#include "KeyScan.h"
#include "KeyProcess.h"
#include "SysDataDefinition.h"
#include "Display.h"
#include "BatteryCheck.h"
#include "Interrupt.h"
#include "LpmProcess.h"
#include "Infra.h"
#include "BacklightDriver.h"
#include "TimerMonitor.h"


unsigned char LPM_flag=0;

void main(void)
{
    //******* check whether wake up from LPM5*******//
    LPM_flag = SYSRSTIV;
    WDTCTL = WDTPW + WDTHOLD;               // stop WDT to avoid generating timeout

    if(LPM_flag &=0x08)          // wake from LPM5
    {
     	 MCU_initlpm();
         InitSysData();
         Release_Ram();
         __enable_interrupt();
         SysData.SysStatus.RTCtimerInterruptFlag =1; //wake up event is RTC
    }
    else                          //reset from power-on
    {
         SET_LCD_ALL_OFF();
         MCU_init();
         InitSysData();
         __enable_interrupt();
         SET_LCD_ALL_ON();
         delay3s();               //LCD light on for 3s
         dispram_init();
         display();
    }

   display();

    for (;;)
    {
         WDTCTL = WDT_ARST_1000;
         if ((SysData.SysStatus.RTCtimerInterruptFlag==0)&&(SysData.SysStatus.light == ON))
            BacklightDrive();

    	 if (SysData.SysStatus.RTCtimerInterruptFlag  == 1) //RTC timer
         {
            timer_monitor();
            check_battery();                                //read ADC
            SysData.SysStatus.RTCtimerInterruptFlag  = 0;
         }

         if (SysData.SysStatus.KeydelayInterruptFlag == 1)  //15ms*4 Delay
         {
            checkkeybutton(); //check key shift
            scan_key();
            KeyProcess(currentkeyid);
         }

         display();

         if (SysData.SysStatus.keypressed==0)
         {
        	Infrared_Send();
        	Sleep();
         }
    }
}
